[tox]
minversion = 1.6
envlist = py27,pep8,py35
skipsdist = True

[testenv]
setenv = VIRTUAL_ENV={envdir}
         PYTHONDONTWRITEBYTECODE = 1
         LANGUAGE=en_US
usedevelop = True
install_command = pip install -c{env:UPPER_CONSTRAINTS_FILE:https://git.openstack.org/cgit/openstack/requirements/plain/upper-constraints.txt} {opts} {packages}
deps = -r{toxinidir}/test-requirements.txt
commands =
           /bin/rm -f .testrepository/times.dbm
           ostestr --slowest {posargs}
whitelist_externals = bash
passenv = *_proxy *_PROXY

[testenv:debug]
commands = oslo_debug_helper {posargs}

[testenv:debug-py27]
basepython = python2.7
commands = oslo_debug_helper {posargs}

[testenv:debug-py35]
basepython = python3.5
commands = oslo_debug_helper {posargs}

[testenv:pep8]
commands =
  flake8 {posargs}
  # Run security linter
  bandit -c bandit.yaml -r glare -n5 -p gate

[testenv:cover]
basepython = python2.7
setenv = VIRTUAL_ENV={envdir}
commands =
    coverage erase
    python setup.py testr --coverage --testr-args='^(?!.*test.*coverage).*$' --omit="*/test*"

[testenv:venv]
commands = {posargs}

[testenv:genconfig]
commands =
  oslo-config-generator --config-file etc/oslo-config-generator/glare.conf

[testenv:genpolicy]
sitepackages = False
envdir = {toxworkdir}/venv
commands =
  oslopolicy-sample-generator --namespace=glare --output-file=etc/policy.yaml.sample

[testenv:docs]
basepython = python2.7
commands = python setup.py build_sphinx

[testenv:bandit]
commands = bandit -c bandit.yaml -r glare -n5 -p gate

[flake8]
# TODO(dmllr): Analyze or fix the warnings blacklisted below
# H404  multi line docstring should start with a summary
# H405  multi line docstring summary not separated with an empty line
ignore = H404,H405
exclude = .venv,.git,.tox,dist,doc,etc,*glare/locale*,*lib/python*,*egg,build
# H904 Delay string interpolations at logging calls.
enable-extensions = H106,H203,H904

[hacking]
local-check-factory = glare.hacking.checks.factory
import_exceptions = glare.i18n
